/*
 * mql_meta_statements.cpp
 *
 * MQL meta-statements
 *
 * Ulrik Petersen
 * Created: 1/19-2002
 * Last update: 11/22-2002
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2002  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, license version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 **************************************************************************/


#include <mql_meta_statements.h>


/////////////////////////////////////////////////////////////
//
// CQuitStatement
//
/////////////////////////////////////////////////////////////
CQuitStatement::CQuitStatement(CMQL_execution_environment *pEE) : CStatement(pEE)
{
}

CQuitStatement::~CQuitStatement()
{
}

bool CQuitStatement::Exec()
{
  m_pEE->bQuit = true;
  return true;
}

