/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_IDENTIFIER = 258,
     T_INTEGER = 259,
     T_STRING = 260,
     T_WSTRING = 261,
     T_LSTRING = 262,
     T_LWSTRING = 263,
     T_KEY_CREATE = 264,
     T_KEY_UPDATE = 265,
     T_KEY_SELECT = 266,
     T_KEY_DROP = 267,
     T_KEY_GET = 268,
     T_KEY_INSERT = 269,
     T_KEY_DELETE = 270,
     T_KEY_DATABASE = 271,
     T_KEY_USE = 272,
     T_KEY_VACUUM = 273,
     T_KEY_ANALYZE = 274,
     T_KEY_TYPE = 275,
     T_KEY_TYPES = 276,
     T_KEY_OBJECT = 277,
     T_KEY_OBJECTS = 278,
     T_KEY_INTEGER = 279,
     T_KEY_STRING = 280,
     T_KEY_WSTRING = 281,
     T_KEY_ASCII = 282,
     T_KEY_ID_D = 283,
     T_KEY_ID_DS = 284,
     T_KEY_DEFAULT = 285,
     T_KEY_COMPUTED = 286,
     T_KEY_ADD = 287,
     T_KEY_REMOVE = 288,
     T_KEY_BUILDABLE_FROM = 289,
     T_KEY_BUILDABLE = 290,
     T_KEY_FROM = 291,
     T_KEY_COVERED_BY = 292,
     T_KEY_COVERED = 293,
     T_KEY_BY = 294,
     T_KEY_ENUM = 295,
     T_KEY_ENUMERATION = 296,
     T_KEY_ENUMERATIONS = 297,
     T_KEY_CONSTANTS = 298,
     T_KEY_SEGMENT = 299,
     T_KEY_SEGMENTS = 300,
     T_KEY_RANGE = 301,
     T_KEY_FOCUS = 302,
     T_KEY_ALL = 303,
     T_KEY_IN = 304,
     T_KEY_WHERE = 305,
     T_KEY_FEATURE = 306,
     T_KEY_FEATURES = 307,
     T_KEY_MONADS = 308,
     T_KEY_MONAD = 309,
     T_KEY_USING = 310,
     T_KEY_WITH = 311,
     T_KEY_HAVING = 312,
     T_KEY_QUERY = 313,
     T_KEY_NORETRIEVE = 314,
     T_KEY_RETRIEVE = 315,
     T_KEY_FIRST = 316,
     T_KEY_LAST = 317,
     T_KEY_OR = 318,
     T_KEY_AND = 319,
     T_KEY_NOT = 320,
     T_KEY_GAP = 321,
     T_KEY_OPT_GAP = 322,
     T_KEY_POWER = 323,
     T_KEY_AS = 324,
     T_KEY_NIL = 325,
     T_KEY_GO = 326,
     T_KEY_RETURNING = 327,
     T_KEY_CALCULATING = 328,
     T_KEY_CALCULATION = 329,
     T_KEY_MIN_M = 330,
     T_KEY_MAX_M = 331,
     T_KEY_FLAT = 332,
     T_KEY_FULL = 333,
     T_KEY_SHEAF = 334,
     T_KEY_AT = 335,
     T_KEY_QUIT = 336,
     T_KEY_SET = 337,
     T_KEY_SETS = 338,
     T_KEY_UNION = 339,
     T_KEY_INTERSECT = 340,
     T_KEY_DIFFERENCE = 341,
     T_KEY_HAS = 342,
     T_KEY_PART_OF = 343,
     T_KEY_LENGTH = 344,
     T_KEY_SUBSTR = 345,
     T_KEY_ENCODING = 346,
     T_KEY_UTF_8 = 347,
     T_KEY_UTF_16 = 348,
     T_KEY_ISO_8859_1 = 349,
     T_KEY_ISO_8859_2 = 350,
     T_KEY_ISO_8859_3 = 351,
     T_KEY_ISO_8859_4 = 352,
     T_KEY_ISO_8859_5 = 353,
     T_KEY_ISO_8859_6 = 354,
     T_KEY_ISO_8859_7 = 355,
     T_KEY_ISO_8859_8 = 356,
     T_KEY_ISO_8859_9 = 357,
     T_KEY_ISO_8859_10 = 358,
     T_KEY_ISO_8859_13 = 359,
     T_KEY_ISO_8859_14 = 360,
     T_KEY_ISO_8859_15 = 361,
     T_KEY_ISO_8859_16 = 362,
     T_KEY_ALL_M = 363,
     T_KEY_ANY_M = 364,
     T_KEY_POW_M = 365,
     T_KEY_EQUALS = 366,
     T_KEY_LESS_THAN = 367,
     T_KEY_GREATER_THAN = 368,
     T_KEY_NOT_EQUAL = 369,
     T_KEY_LESS_THAN_OR_EQUAL = 370,
     T_KEY_GREATER_THAN_OR_EQUAL = 371,
     T_KEY_TILDE = 372,
     T_KEY_NOT_TILDE = 373,
     T_KEY_OPEN_SQUARE_BRACKET = 374,
     T_KEY_CLOSE_SQUARE_BRACKET = 375,
     T_KEY_OPEN_BRACE = 376,
     T_KEY_CLOSE_BRACE = 377,
     T_KEY_OPEN_BRACKET = 378,
     T_KEY_CLOSE_BRACKET = 379,
     T_KEY_ASSIGN = 380,
     T_KEY_COLON = 381,
     T_KEY_SEMICOLON = 382,
     T_KEY_COMMA = 383,
     T_KEY_DOT = 384,
     T_KEY_DASH = 385,
     T_KEY_EXCLAMATION = 386,
     T_KEY_BACKSLASH = 387,
     T_KEY_PIPE = 388
   };
#endif
#define T_IDENTIFIER 258
#define T_INTEGER 259
#define T_STRING 260
#define T_WSTRING 261
#define T_LSTRING 262
#define T_LWSTRING 263
#define T_KEY_CREATE 264
#define T_KEY_UPDATE 265
#define T_KEY_SELECT 266
#define T_KEY_DROP 267
#define T_KEY_GET 268
#define T_KEY_INSERT 269
#define T_KEY_DELETE 270
#define T_KEY_DATABASE 271
#define T_KEY_USE 272
#define T_KEY_VACUUM 273
#define T_KEY_ANALYZE 274
#define T_KEY_TYPE 275
#define T_KEY_TYPES 276
#define T_KEY_OBJECT 277
#define T_KEY_OBJECTS 278
#define T_KEY_INTEGER 279
#define T_KEY_STRING 280
#define T_KEY_WSTRING 281
#define T_KEY_ASCII 282
#define T_KEY_ID_D 283
#define T_KEY_ID_DS 284
#define T_KEY_DEFAULT 285
#define T_KEY_COMPUTED 286
#define T_KEY_ADD 287
#define T_KEY_REMOVE 288
#define T_KEY_BUILDABLE_FROM 289
#define T_KEY_BUILDABLE 290
#define T_KEY_FROM 291
#define T_KEY_COVERED_BY 292
#define T_KEY_COVERED 293
#define T_KEY_BY 294
#define T_KEY_ENUM 295
#define T_KEY_ENUMERATION 296
#define T_KEY_ENUMERATIONS 297
#define T_KEY_CONSTANTS 298
#define T_KEY_SEGMENT 299
#define T_KEY_SEGMENTS 300
#define T_KEY_RANGE 301
#define T_KEY_FOCUS 302
#define T_KEY_ALL 303
#define T_KEY_IN 304
#define T_KEY_WHERE 305
#define T_KEY_FEATURE 306
#define T_KEY_FEATURES 307
#define T_KEY_MONADS 308
#define T_KEY_MONAD 309
#define T_KEY_USING 310
#define T_KEY_WITH 311
#define T_KEY_HAVING 312
#define T_KEY_QUERY 313
#define T_KEY_NORETRIEVE 314
#define T_KEY_RETRIEVE 315
#define T_KEY_FIRST 316
#define T_KEY_LAST 317
#define T_KEY_OR 318
#define T_KEY_AND 319
#define T_KEY_NOT 320
#define T_KEY_GAP 321
#define T_KEY_OPT_GAP 322
#define T_KEY_POWER 323
#define T_KEY_AS 324
#define T_KEY_NIL 325
#define T_KEY_GO 326
#define T_KEY_RETURNING 327
#define T_KEY_CALCULATING 328
#define T_KEY_CALCULATION 329
#define T_KEY_MIN_M 330
#define T_KEY_MAX_M 331
#define T_KEY_FLAT 332
#define T_KEY_FULL 333
#define T_KEY_SHEAF 334
#define T_KEY_AT 335
#define T_KEY_QUIT 336
#define T_KEY_SET 337
#define T_KEY_SETS 338
#define T_KEY_UNION 339
#define T_KEY_INTERSECT 340
#define T_KEY_DIFFERENCE 341
#define T_KEY_HAS 342
#define T_KEY_PART_OF 343
#define T_KEY_LENGTH 344
#define T_KEY_SUBSTR 345
#define T_KEY_ENCODING 346
#define T_KEY_UTF_8 347
#define T_KEY_UTF_16 348
#define T_KEY_ISO_8859_1 349
#define T_KEY_ISO_8859_2 350
#define T_KEY_ISO_8859_3 351
#define T_KEY_ISO_8859_4 352
#define T_KEY_ISO_8859_5 353
#define T_KEY_ISO_8859_6 354
#define T_KEY_ISO_8859_7 355
#define T_KEY_ISO_8859_8 356
#define T_KEY_ISO_8859_9 357
#define T_KEY_ISO_8859_10 358
#define T_KEY_ISO_8859_13 359
#define T_KEY_ISO_8859_14 360
#define T_KEY_ISO_8859_15 361
#define T_KEY_ISO_8859_16 362
#define T_KEY_ALL_M 363
#define T_KEY_ANY_M 364
#define T_KEY_POW_M 365
#define T_KEY_EQUALS 366
#define T_KEY_LESS_THAN 367
#define T_KEY_GREATER_THAN 368
#define T_KEY_NOT_EQUAL 369
#define T_KEY_LESS_THAN_OR_EQUAL 370
#define T_KEY_GREATER_THAN_OR_EQUAL 371
#define T_KEY_TILDE 372
#define T_KEY_NOT_TILDE 373
#define T_KEY_OPEN_SQUARE_BRACKET 374
#define T_KEY_CLOSE_SQUARE_BRACKET 375
#define T_KEY_OPEN_BRACE 376
#define T_KEY_CLOSE_BRACE 377
#define T_KEY_OPEN_BRACKET 378
#define T_KEY_CLOSE_BRACKET 379
#define T_KEY_ASSIGN 380
#define T_KEY_COLON 381
#define T_KEY_SEMICOLON 382
#define T_KEY_COMMA 383
#define T_KEY_DOT 384
#define T_KEY_DASH 385
#define T_KEY_EXCLAMATION 386
#define T_KEY_BACKSLASH 387
#define T_KEY_PIPE 388




/* Copy the first part of user declarations.  */
#line 1 "mql.yxx"


/*
 * mql.yxx
 *
 * MQL parser
 *
 * Ulrik Petersen
 * Created: 2/27-2001
 * Last update: 6/21-2002
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2001-2003  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, license version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 **************************************************************************/



#include <cstdlib>
#include <string>
#include <mql_error.h>
#include <mql_types.h>
#include <mql_database_statements.h>
#include <mql_enumeration_statements.h>
#include <mql_features_statements.h>
#include <mql_meta_statements.h>
#include <mql_monads_statements.h>
#include <mql_object_statements.h>
#include <mql_object_type_statements.h>
#include <mql_segment_statements.h>
#include <mql_select_statements.h>
#include <mql_query.h>
#include <mql_extern.h>
#include <mql_execution_environment.h>
#include <mql_yylex.h>




/* Make bison output verbose error messages on parse error. */
#define YYERROR_VERBOSE

/* Make bison accept an extra parameter, the CMQL_execution_environment */
#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm

#define yyerror(s)                      \
   { ((CMQL_execution_environment*) parm)->pError->mql_append_error(s); }


  /*
int yyerror(const char *s)
{
  mql_append_error(s);
  mql_append_error("\n");
  return 1;
}
*/



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 225 "mql.yxx"
typedef union YYSTYPE {
  std::string*             pString;
  long                     integer;
  bool                     boolean;
  eFocusSpec               focus;
  eRetrieval               retrieval;
  eFirstLast               firstlast;
  eComparisonOp            comparison_op;
  eSetOperator             set_operator;
  CStatement*              pStatement;
  CType*                   pType;
  CExpression*             pExpression;
  CFeatureDeclaration*     pFeatureDeclaration;
  CObjectTypeName*         pObjectTypeName;
  CCBBFList*               pCBBFList;
  CFeatureUpdate*          pFeatureUpdate;
  CMonadSetElement*        pMonadSetElement;
  CMonadSetChainElement*   pMonadSetChainElement;
  CECDeclaration*          pECDeclaration;
  long*                    pLong;
  CECUpdate*               pECUpdate;
  CFeatureAssignment*      pFeatureAssignment;
  CObjectSpec*             pObjectSpec;
  CID_D*                   pID_D;
  CFeature*                pFeature;
  CGap_block*              pGapBlock;
  COpt_gap_block*          pOptGapBlock;
  CBlock*                  pBlock;
  CRest_of_block_str*      pRest_of_block_str;
  CObject_reference_usage* pObjectReferenceUsage;
  CValue*                  pValue;
  CFeature_comparison*     pFeature_comparison;
  CFFactor*                pFFactor;
  CFTerm*                  pFTerm;
  CFFeatures*              pFFeatures;
  CObject_block*           pObject_block;
  CObject_block_first*     pObject_block_first;
  CBlock_str*              pBlock_str;
  CPower*                  pPower;
  CBlock_string*           pBlock_string;
  CBlocks*                 pBlocks;
  CTopograph*              pTopograph;
  sheaf_return_type_t      sheaf_return_type;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 475 "mql_parser.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 487 "mql_parser.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  95
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   435

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  134
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  152
/* YYNRULES -- Number of rules. */
#define YYNRULES  290
/* YYNRULES -- Number of states. */
#define YYNSTATES  504

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   388

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    46,    48,    50,    52,    54,    56,    58,
      60,    62,    64,    66,    68,    70,    72,    74,    76,    78,
      80,    82,    86,    88,    92,    94,    95,    99,   103,   104,
     106,   115,   117,   118,   120,   122,   123,   125,   128,   135,
     137,   140,   143,   145,   147,   148,   152,   155,   156,   158,
     159,   161,   162,   164,   167,   169,   171,   174,   177,   179,
     181,   185,   188,   191,   193,   202,   204,   207,   210,   214,
     216,   217,   219,   220,   222,   225,   227,   229,   231,   233,
     237,   241,   245,   249,   256,   259,   262,   272,   277,   279,
     283,   285,   287,   289,   297,   299,   301,   303,   305,   309,
     313,   315,   316,   318,   320,   321,   329,   331,   335,   340,
     345,   348,   351,   353,   356,   358,   362,   369,   371,   375,
     379,   385,   389,   391,   393,   395,   396,   399,   400,   402,
     404,   408,   410,   414,   416,   420,   424,   425,   426,   430,
     434,   437,   445,   449,   459,   461,   463,   467,   475,   478,
     480,   481,   484,   491,   493,   495,   496,   503,   506,   509,
     512,   519,   523,   528,   529,   531,   533,   538,   540,   541,
     543,   546,   551,   553,   555,   557,   559,   566,   570,   572,
     574,   576,   580,   582,   594,   600,   602,   604,   609,   615,
     624,   628,   634,   638,   640,   642,   648,   659,   670,   672,
     674,   676,   680,   682,   684,   686,   688,   690,   694,   696,
     700,   703,   713,   714,   717,   719,   720,   722,   724,   726,
     727,   729,   731,   735,   736,   738,   740,   744,   746,   750,
     753,   757,   759,   763,   765,   767,   769,   771,   773,   775,
     777,   779,   781,   783,   785,   787,   789,   793,   794,   796,
     798,   802,   805,   807,   809,   811,   817,   818,   820,   822,
     824,   830,   833,   834,   844,   845,   847,   850,   851,   854,
     857
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
     135,     0,    -1,   136,    71,    -1,   137,    -1,   139,    -1,
     141,    -1,   142,    -1,   144,    -1,   162,    -1,   173,    -1,
     174,    -1,   175,    -1,   176,    -1,   177,    -1,   180,    -1,
     188,    -1,   193,    -1,   194,    -1,   197,    -1,   198,    -1,
     210,    -1,   212,    -1,   214,    -1,   215,    -1,   217,    -1,
     218,    -1,   220,    -1,   221,    -1,   222,    -1,   223,    -1,
     224,    -1,   234,    -1,   239,    -1,   240,    -1,   243,    -1,
     244,    -1,   246,    -1,   249,    -1,   250,    -1,   251,    -1,
     254,    -1,     9,    16,   138,    -1,     3,    -1,    17,   140,
     138,    -1,    16,    -1,    -1,    12,    16,   138,    -1,    18,
     140,   143,    -1,    -1,    19,    -1,     9,   145,    20,   119,
     146,   147,   120,   154,    -1,    22,    -1,    -1,     3,    -1,
     148,    -1,    -1,   149,    -1,   148,   149,    -1,   232,   126,
     150,   152,   153,   127,    -1,    24,    -1,    25,   151,    -1,
      27,   151,    -1,    28,    -1,     3,    -1,    -1,   123,     4,
     124,    -1,    30,   233,    -1,    -1,    31,    -1,    -1,   155,
      -1,    -1,   156,    -1,   155,   156,    -1,   160,    -1,   157,
      -1,   158,   159,    -1,    35,    36,    -1,    34,    -1,   146,
      -1,   159,   128,   146,    -1,   161,   159,    -1,    38,    39,
      -1,    37,    -1,    10,   145,    20,   119,   146,   163,   120,
     166,    -1,   164,    -1,   163,   164,    -1,   165,   149,    -1,
      33,   232,   127,    -1,    32,    -1,    -1,   167,    -1,    -1,
     168,    -1,   167,   168,    -1,   169,    -1,   170,    -1,   171,
      -1,   172,    -1,    32,   161,   159,    -1,    33,   161,   159,
      -1,    32,   158,   159,    -1,    33,   158,   159,    -1,    12,
     145,    20,   119,   146,   120,    -1,    14,   225,    -1,    15,
     225,    -1,    13,    53,    36,   241,    56,   235,   119,   146,
     120,    -1,    54,    82,    74,   178,    -1,   204,    -1,   178,
     179,   204,    -1,    84,    -1,    86,    -1,    85,    -1,     9,
     181,   182,   111,   121,   183,   122,    -1,    41,    -1,    40,
      -1,     3,    -1,   184,    -1,   183,   128,   184,    -1,   185,
     186,   187,    -1,    30,    -1,    -1,     3,    -1,   191,    -1,
      -1,    10,   181,   182,   111,   121,   189,   122,    -1,   190,
      -1,   189,   128,   190,    -1,   165,   185,   186,   191,    -1,
      10,   185,   186,   191,    -1,    33,   186,    -1,   111,   192,
      -1,     4,    -1,   130,     4,    -1,    70,    -1,    12,   181,
     182,    -1,     9,    44,   195,    46,   111,   196,    -1,     3,
      -1,     4,   130,     4,    -1,    12,    44,   195,    -1,   199,
     202,   207,   208,   209,    -1,    11,   200,   201,    -1,    47,
      -1,    48,    -1,    23,    -1,    -1,    49,   203,    -1,    -1,
     204,    -1,    48,    -1,   121,   205,   122,    -1,   206,    -1,
     205,   128,   206,    -1,     4,    -1,     4,   130,     4,    -1,
      55,    44,   195,    -1,    -1,    -1,    72,    78,    79,    -1,
      72,    77,    79,    -1,    50,   255,    -1,    11,   201,    80,
     211,   119,   146,   120,    -1,    54,   111,     4,    -1,    11,
      23,    57,    53,    49,   204,   119,   213,   120,    -1,   146,
      -1,    48,    -1,    11,   145,    21,    -1,    11,    52,    36,
     216,   119,   146,   120,    -1,    22,    20,    -1,    20,    -1,
      -1,    11,    42,    -1,    11,   181,    43,    36,   219,   182,
      -1,    40,    -1,    41,    -1,    -1,    11,   145,    21,    55,
     181,   182,    -1,    11,    45,    -1,    11,    75,    -1,    11,
      76,    -1,     9,    22,    36,   225,   226,   228,    -1,    53,
     111,   204,    -1,    56,    28,   111,   227,    -1,    -1,     4,
      -1,    70,    -1,   119,   146,   229,   120,    -1,   230,    -1,
      -1,   231,    -1,   230,   231,    -1,   232,   125,   233,   127,
      -1,     3,    -1,   192,    -1,     5,    -1,     3,    -1,     9,
      22,    36,   235,   226,   228,    -1,   236,   111,   237,    -1,
      28,    -1,    29,    -1,   238,    -1,   237,   128,   238,    -1,
     227,    -1,     9,    22,    36,   200,    58,   226,   228,   202,
     207,   208,   209,    -1,    10,   241,    39,   225,   242,    -1,
      22,    -1,    23,    -1,   119,   146,   230,   120,    -1,    10,
     241,    39,   235,   242,    -1,    10,   241,   245,   242,   202,
     207,   208,   209,    -1,    39,   200,    58,    -1,    15,   241,
      39,   225,   247,    -1,   119,   248,   120,    -1,   146,    -1,
      48,    -1,    15,   241,    39,   235,   247,    -1,    15,   241,
      39,   200,    58,   247,   202,   207,   208,   209,    -1,    13,
     252,   253,    36,   241,    56,   235,   119,   146,   120,    -1,
      51,    -1,    52,    -1,   232,    -1,   253,   128,   232,    -1,
      81,    -1,   256,    -1,   257,    -1,   258,    -1,   259,    -1,
     259,   283,   258,    -1,   260,    -1,   260,   131,   275,    -1,
     260,   275,    -1,   119,   146,   261,   263,   264,   265,   280,
     274,   120,    -1,    -1,    69,   262,    -1,     3,    -1,    -1,
      59,    -1,    60,    -1,    47,    -1,    -1,    61,    -1,    62,
      -1,    61,    64,    62,    -1,    -1,   266,    -1,   267,    -1,
     266,    63,   267,    -1,   268,    -1,   268,    64,   267,    -1,
      65,   268,    -1,   123,   266,   124,    -1,   269,    -1,   232,
     270,   271,    -1,   111,    -1,   112,    -1,   113,    -1,   114,
      -1,   115,    -1,   116,    -1,   117,    -1,   118,    -1,   272,
      -1,   192,    -1,     5,    -1,   273,    -1,     3,    -1,   262,
     129,   232,    -1,    -1,   257,    -1,   276,    -1,   276,   131,
     275,    -1,   276,   275,    -1,   277,    -1,   279,    -1,   281,
      -1,   119,    67,   278,   274,   120,    -1,    -1,    59,    -1,
      60,    -1,    47,    -1,   119,    66,   278,   274,   120,    -1,
      13,   253,    -1,    -1,   119,   146,   261,   263,   282,   265,
     280,   274,   120,    -1,    -1,    62,    -1,    68,   284,    -1,
      -1,   112,   285,    -1,   115,   285,    -1,     4,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   422,   422,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   466,   471,   475,   479,   479,   482,   487,   493,   494,
     498,   506,   506,   509,   513,   516,   519,   521,   525,   530,
     532,   534,   536,   538,   543,   544,   548,   551,   554,   557,
     561,   564,   567,   569,   573,   575,   580,   585,   586,   589,
     591,   595,   600,   601,   604,   612,   614,   618,   620,   624,
     624,   627,   630,   633,   635,   639,   640,   641,   642,   645,
     650,   655,   660,   665,   671,   675,   679,   686,   692,   694,
     698,   700,   702,   707,   713,   715,   719,   723,   725,   729,
     733,   736,   739,   743,   747,   750,   756,   758,   762,   765,
     767,   771,   775,   777,   779,   783,   789,   795,   799,   803,
     808,   816,   820,   822,   826,   827,   830,   833,   836,   838,
     842,   846,   848,   852,   854,   858,   861,   865,   866,   868,
     872,   876,   884,   889,   898,   900,   904,   909,   915,   916,
     917,   920,   925,   932,   933,   934,   937,   944,   948,   952,
     956,   963,   967,   970,   973,   975,   979,   986,   989,   992,
     994,   998,  1002,  1006,  1008,  1010,  1014,  1021,  1025,  1025,
    1029,  1031,  1035,  1039,  1051,  1058,  1058,  1062,  1069,  1077,
    1088,  1093,  1100,  1106,  1108,  1113,  1121,  1135,  1144,  1144,
    1148,  1150,  1154,  1158,  1162,  1166,  1170,  1172,  1176,  1178,
    1180,  1192,  1202,  1203,  1207,  1212,  1213,  1215,  1217,  1222,
    1223,  1225,  1227,  1232,  1233,  1237,  1239,  1243,  1245,  1249,
    1251,  1253,  1257,  1261,  1263,  1265,  1267,  1269,  1271,  1273,
    1275,  1281,  1283,  1285,  1287,  1291,  1295,  1300,  1301,  1305,
    1307,  1309,  1322,  1324,  1326,  1330,  1335,  1336,  1338,  1340,
    1344,  1349,  1352,  1355,  1365,  1366,  1370,  1375,  1376,  1378,
    1382
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_IDENTIFIER", "T_INTEGER", "T_STRING", 
  "T_WSTRING", "T_LSTRING", "T_LWSTRING", "T_KEY_CREATE", "T_KEY_UPDATE", 
  "T_KEY_SELECT", "T_KEY_DROP", "T_KEY_GET", "T_KEY_INSERT", 
  "T_KEY_DELETE", "T_KEY_DATABASE", "T_KEY_USE", "T_KEY_VACUUM", 
  "T_KEY_ANALYZE", "T_KEY_TYPE", "T_KEY_TYPES", "T_KEY_OBJECT", 
  "T_KEY_OBJECTS", "T_KEY_INTEGER", "T_KEY_STRING", "T_KEY_WSTRING", 
  "T_KEY_ASCII", "T_KEY_ID_D", "T_KEY_ID_DS", "T_KEY_DEFAULT", 
  "T_KEY_COMPUTED", "T_KEY_ADD", "T_KEY_REMOVE", "T_KEY_BUILDABLE_FROM", 
  "T_KEY_BUILDABLE", "T_KEY_FROM", "T_KEY_COVERED_BY", "T_KEY_COVERED", 
  "T_KEY_BY", "T_KEY_ENUM", "T_KEY_ENUMERATION", "T_KEY_ENUMERATIONS", 
  "T_KEY_CONSTANTS", "T_KEY_SEGMENT", "T_KEY_SEGMENTS", "T_KEY_RANGE", 
  "T_KEY_FOCUS", "T_KEY_ALL", "T_KEY_IN", "T_KEY_WHERE", "T_KEY_FEATURE", 
  "T_KEY_FEATURES", "T_KEY_MONADS", "T_KEY_MONAD", "T_KEY_USING", 
  "T_KEY_WITH", "T_KEY_HAVING", "T_KEY_QUERY", "T_KEY_NORETRIEVE", 
  "T_KEY_RETRIEVE", "T_KEY_FIRST", "T_KEY_LAST", "T_KEY_OR", "T_KEY_AND", 
  "T_KEY_NOT", "T_KEY_GAP", "T_KEY_OPT_GAP", "T_KEY_POWER", "T_KEY_AS", 
  "T_KEY_NIL", "T_KEY_GO", "T_KEY_RETURNING", "T_KEY_CALCULATING", 
  "T_KEY_CALCULATION", "T_KEY_MIN_M", "T_KEY_MAX_M", "T_KEY_FLAT", 
  "T_KEY_FULL", "T_KEY_SHEAF", "T_KEY_AT", "T_KEY_QUIT", "T_KEY_SET", 
  "T_KEY_SETS", "T_KEY_UNION", "T_KEY_INTERSECT", "T_KEY_DIFFERENCE", 
  "T_KEY_HAS", "T_KEY_PART_OF", "T_KEY_LENGTH", "T_KEY_SUBSTR", 
  "T_KEY_ENCODING", "T_KEY_UTF_8", "T_KEY_UTF_16", "T_KEY_ISO_8859_1", 
  "T_KEY_ISO_8859_2", "T_KEY_ISO_8859_3", "T_KEY_ISO_8859_4", 
  "T_KEY_ISO_8859_5", "T_KEY_ISO_8859_6", "T_KEY_ISO_8859_7", 
  "T_KEY_ISO_8859_8", "T_KEY_ISO_8859_9", "T_KEY_ISO_8859_10", 
  "T_KEY_ISO_8859_13", "T_KEY_ISO_8859_14", "T_KEY_ISO_8859_15", 
  "T_KEY_ISO_8859_16", "T_KEY_ALL_M", "T_KEY_ANY_M", "T_KEY_POW_M", 
  "T_KEY_EQUALS", "T_KEY_LESS_THAN", "T_KEY_GREATER_THAN", 
  "T_KEY_NOT_EQUAL", "T_KEY_LESS_THAN_OR_EQUAL", 
  "T_KEY_GREATER_THAN_OR_EQUAL", "T_KEY_TILDE", "T_KEY_NOT_TILDE", 
  "T_KEY_OPEN_SQUARE_BRACKET", "T_KEY_CLOSE_SQUARE_BRACKET", 
  "T_KEY_OPEN_BRACE", "T_KEY_CLOSE_BRACE", "T_KEY_OPEN_BRACKET", 
  "T_KEY_CLOSE_BRACKET", "T_KEY_ASSIGN", "T_KEY_COLON", "T_KEY_SEMICOLON", 
  "T_KEY_COMMA", "T_KEY_DOT", "T_KEY_DASH", "T_KEY_EXCLAMATION", 
  "T_KEY_BACKSLASH", "T_KEY_PIPE", "$accept", "statement", 
  "statement_by_itself", "create_database_statement", "database_name", 
  "use_statement", "opt_DATABASE", "drop_database_statement", 
  "vacuum_database_statement", "opt_ANALYZE", 
  "create_object_type_statement", "opt_OBJECT", "object_type_name", 
  "opt_feature_declaration_list", "feature_declaration_list", 
  "feature_declaration", "feature_type", "opt_string_length", 
  "default_specification", "opt_COMPUTED", 
  "opt_covered_by_buildable_from_list", "covered_by_buildable_from_list", 
  "covered_by_buildable_from", "buildable_from_specification", 
  "choice_BUILDABLE_FROM", "object_type_list", "covered_by_specification", 
  "choice_COVERED_BY", "update_object_type_statement", 
  "feature_update_list", "feature_update", "opt_ADD", 
  "opt_add_remove_list", "add_remove_list", "add_or_remove", 
  "add_covered_by", "remove_covered_by", "add_buildable_from", 
  "remove_buildable_from", "drop_object_type_statement", 
  "insert_monads_statement", "delete_monads_statement", 
  "get_monads_statement", "monad_set_calculation_statement", 
  "monad_set_chain", "monad_set_operator", "create_enumeration_statement", 
  "choice_ENUM_ERATION", "enumeration_name", "ec_declaration_list", 
  "ec_declaration", "opt_DEFAULT", "ec_name", "opt_ec_initialization", 
  "update_enumeration_statement", "ec_update_list", "ec_update", 
  "ec_initialization", "signed_integer", "drop_enumeration_statement", 
  "create_segment_statement", "segment_name", "segment_range", 
  "drop_segment_statement", "select_statement", "select_clause", 
  "focus_specification", "opt_OBJECTS", "in_clause", "in_specification", 
  "monad_set", "monad_set_element_list", "monad_set_element", 
  "using_segment_clause", "returning_clause", "where_clause", 
  "select_objects_at_statement", "single_monad_specification", 
  "select_objects_having_monads_in_statement", "object_type_to_find", 
  "select_object_types_statement", "select_features_statement", 
  "opt_OBJECT_TYPE", "select_enumerations_statement", 
  "select_enumeration_constants_statement", "opt_ENUM_ERATION", 
  "select_object_types_which_use_enum_statement", 
  "select_segments_statement", "select_min_m_statement", 
  "select_max_m_statement", "create_object_from_monads_statement", 
  "monad_specification", "with_id_d_specification", "id_d_const", 
  "object_creation_specification", "opt_list_of_feature_assignments", 
  "list_of_feature_assignments", "feature_assignment", "feature_name", 
  "expression", "create_object_from_id_ds_statement", 
  "id_ds_specification", "choice_number_ID_DS", "id_d_list", "id_d", 
  "create_object_from_query_statement", 
  "update_objects_by_monads_statement", "choice_number_OBJECTS", 
  "object_update_specification", "update_objects_by_id_ds_statement", 
  "update_objects_by_query_statement", "by_query_specification", 
  "delete_objects_by_monads_statement", "object_deletion_specification", 
  "object_type_name_to_delete", "delete_objects_by_id_ds_statement", 
  "delete_objects_by_query_statement", "get_features_statement", 
  "choice_number_FEATURES", "feature_list", "quit_statement", "mql_query", 
  "topograph", "blocks", "block_string", "block_str", 
  "object_block_first", "object_reference_declaration", 
  "object_reference", "retrieval", "firstlast", "feature_constraints", 
  "ffeatures", "fterm", "ffactor", "feature_comparison", 
  "comparison_operator", "value", "enum_const", "object_reference_usage", 
  "opt_blocks", "rest_of_block_str", "block", "opt_gap_block", 
  "gap_retrieval", "gap_block", "feature_retrieval", "object_block", 
  "last", "power", "restrictor", "limit", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short yyr1[] =
{
       0,   134,   135,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   137,   138,   139,   140,   140,   141,   142,   143,   143,
     144,   145,   145,   146,   147,   147,   148,   148,   149,   150,
     150,   150,   150,   150,   151,   151,   152,   152,   153,   153,
     154,   154,   155,   155,   156,   156,   157,   158,   158,   159,
     159,   160,   161,   161,   162,   163,   163,   164,   164,   165,
     165,   166,   166,   167,   167,   168,   168,   168,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   178,
     179,   179,   179,   180,   181,   181,   182,   183,   183,   184,
     185,   185,   186,   187,   187,   188,   189,   189,   190,   190,
     190,   191,   192,   192,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   200,   201,   201,   202,   202,   203,   203,
     204,   205,   205,   206,   206,   207,   207,   208,   208,   208,
     209,   210,   211,   212,   213,   213,   214,   215,   216,   216,
     216,   217,   218,   219,   219,   219,   220,   221,   222,   223,
     224,   225,   226,   226,   227,   227,   228,   229,   229,   230,
     230,   231,   232,   233,   233,   233,   234,   235,   236,   236,
     237,   237,   238,   239,   240,   241,   241,   242,   243,   244,
     245,   246,   247,   248,   248,   249,   250,   251,   252,   252,
     253,   253,   254,   255,   256,   257,   258,   258,   259,   259,
     259,   260,   261,   261,   262,   263,   263,   263,   263,   264,
     264,   264,   264,   265,   265,   266,   266,   267,   267,   268,
     268,   268,   269,   270,   270,   270,   270,   270,   270,   270,
     270,   271,   271,   271,   271,   272,   273,   274,   274,   275,
     275,   275,   276,   276,   276,   277,   278,   278,   278,   278,
     279,   280,   280,   281,   282,   282,   283,   284,   284,   284,
     285
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     0,     3,     3,     0,     1,
       8,     1,     0,     1,     1,     0,     1,     2,     6,     1,
       2,     2,     1,     1,     0,     3,     2,     0,     1,     0,
       1,     0,     1,     2,     1,     1,     2,     2,     1,     1,
       3,     2,     2,     1,     8,     1,     2,     2,     3,     1,
       0,     1,     0,     1,     2,     1,     1,     1,     1,     3,
       3,     3,     3,     6,     2,     2,     9,     4,     1,     3,
       1,     1,     1,     7,     1,     1,     1,     1,     3,     3,
       1,     0,     1,     1,     0,     7,     1,     3,     4,     4,
       2,     2,     1,     2,     1,     3,     6,     1,     3,     3,
       5,     3,     1,     1,     1,     0,     2,     0,     1,     1,
       3,     1,     3,     1,     3,     3,     0,     0,     3,     3,
       2,     7,     3,     9,     1,     1,     3,     7,     2,     1,
       0,     2,     6,     1,     1,     0,     6,     2,     2,     2,
       6,     3,     4,     0,     1,     1,     4,     1,     0,     1,
       2,     4,     1,     1,     1,     1,     6,     3,     1,     1,
       1,     3,     1,    11,     5,     1,     1,     4,     5,     8,
       3,     5,     3,     1,     1,     5,    10,    10,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     3,     1,     3,
       2,     9,     0,     2,     1,     0,     1,     1,     1,     0,
       1,     1,     3,     0,     1,     1,     3,     1,     3,     2,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     1,     1,
       3,     2,     1,     1,     1,     5,     0,     1,     1,     1,
       5,     2,     0,     9,     0,     1,     2,     0,     2,     2,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short yydefact[] =
{
       0,    52,    52,    52,    52,     0,     0,     0,    45,    45,
       0,   222,     0,     0,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,   147,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,     0,    51,   115,   114,     0,     0,     0,
      51,   206,     0,     0,     0,    51,   144,   171,   177,   142,
     143,     0,   178,   179,     0,     0,   145,     0,     0,     0,
       0,     0,   218,   219,     0,     0,     0,   104,   205,   105,
       0,    44,     0,    48,     0,     1,     2,     0,   156,    42,
      41,     0,   137,     0,     0,   116,     0,     0,     0,     0,
       0,     0,   170,   166,     0,   144,   141,     0,    46,   139,
       0,   135,     0,   192,   220,     0,     0,     0,    43,    49,
      47,     0,   149,     0,   146,   148,     0,   157,   198,   199,
       0,   183,   183,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,   169,     0,     0,     0,   175,
       0,     0,     0,     0,     0,     0,   181,     0,     0,     0,
     107,   108,   153,     0,   151,     0,     0,     0,   183,     0,
       0,     0,     0,     0,    53,    55,   121,    90,    90,   210,
     204,   208,     0,   156,     0,   168,     0,     0,   173,   174,
       0,     0,     0,     0,     0,     0,   221,     0,     0,   211,
     215,   110,   112,   111,     0,     0,   150,     0,   155,     0,
       0,     0,   140,     0,     0,     0,   180,   196,   184,   185,
     202,   197,   200,     0,   136,     0,    54,    56,     0,   120,
       0,   117,     0,    89,     0,    90,    85,     0,   121,     0,
     121,     0,   126,     0,   189,     0,   157,     0,     0,   176,
     172,   162,     0,   103,     0,     0,   147,   214,   213,     0,
     109,   154,   152,   159,   158,     0,   160,   223,   224,   225,
     226,   228,   147,     0,   188,     0,     0,    71,    57,     0,
     113,   121,   122,   124,     0,    92,    86,    87,     0,   130,
       0,   125,    90,   207,   190,     0,     0,     0,   167,   161,
       0,     0,   156,   212,   232,   287,     0,     0,     0,   230,
     269,   272,   273,   274,   156,   182,     0,   187,   201,   138,
      78,     0,    83,     0,    50,    70,    72,    75,     0,    74,
       0,    63,    59,    64,    64,    62,    67,   118,     0,   119,
     123,    88,     0,     0,    84,    91,    93,    95,    96,    97,
      98,     0,     0,   127,   195,   132,   194,   134,     0,   193,
       0,   209,   165,   164,     0,     0,     0,   157,     0,   235,
       0,     0,   286,   227,   276,   276,   232,   229,     0,   271,
     157,   186,    77,    82,    73,    79,    76,    81,     0,    60,
      61,     0,    69,   131,     0,     0,     0,     0,    94,   129,
     128,   133,   191,   163,   106,     0,     0,   234,   233,   238,
     236,   237,   239,   290,   288,   289,   279,   277,   278,   267,
     267,   235,   270,     0,     0,     0,    66,    68,     0,   101,
      99,   102,   100,   217,   216,   240,   241,   243,   268,     0,
       0,   284,   203,    80,    65,    58,     0,     0,     0,     0,
     282,   244,   245,   247,   251,   280,   275,   285,   243,   242,
     249,     0,   253,   254,   255,   256,   257,   258,   259,   260,
       0,     0,   267,     0,     0,   282,   250,   265,   263,   262,
       0,   252,   261,   264,   281,     0,   246,   248,   267,     0,
     231,     0,   266,   283
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    12,    13,    14,   100,    15,    92,    16,    17,   130,
      18,    58,   395,   235,   236,   237,   346,   399,   402,   438,
     334,   335,   336,   337,   338,   396,   339,   340,    19,   245,
     246,   247,   354,   355,   356,   357,   358,   359,   360,    20,
      21,    22,    23,    24,   170,   214,    25,    59,   106,   240,
     241,   242,   293,   349,    26,   251,   252,   350,   369,    27,
      28,   103,   234,    29,    30,    31,    76,    77,    98,   134,
     135,   173,   174,   137,   177,   222,    32,   161,    33,   374,
      34,    35,   157,    36,    37,   200,    38,    39,    40,    41,
      42,    87,   180,   230,   226,   326,   253,   254,   459,   370,
      43,   142,   143,   231,   232,    44,    45,    64,   153,    46,
      47,   110,    48,   209,   269,    49,    50,    51,    85,   125,
      52,   276,   277,   448,   279,   280,   281,   379,   418,   422,
     447,   460,   461,   462,   463,   464,   480,   491,   492,   493,
     449,   319,   320,   321,   429,   322,   482,   323,   468,   316,
     382,   424
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -394
static const short yypact[] =
{
      30,   138,   161,   148,   164,   162,    37,    50,    69,    69,
      34,  -394,   112,    82,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,   107,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,   169,   128,  -394,  -394,   182,   147,   191,
     170,  -394,   178,   191,   173,  -394,   146,  -394,  -394,  -394,
    -394,   181,  -394,  -394,   199,   188,   202,   193,   169,   182,
     251,   191,  -394,  -394,   205,   269,   165,  -394,  -394,  -394,
     235,  -394,   169,   256,   203,  -394,  -394,   -17,   223,  -394,
    -394,   163,  -394,   233,   167,  -394,   171,   168,   172,   163,
     175,   228,    54,   229,   249,  -394,  -394,   226,  -394,  -394,
     176,  -394,    39,  -394,  -394,   -15,   177,   163,  -394,  -394,
    -394,   177,  -394,   284,  -394,  -394,   245,   219,  -394,  -394,
     234,   237,   237,   185,   186,   296,   179,   296,   180,   246,
     175,   175,   296,   107,   253,  -394,   283,   187,   166,   209,
     196,   189,   296,   254,    39,   269,  -394,   247,   190,   190,
     159,  -394,   183,   -35,  -394,   182,   174,   261,   237,   286,
     197,   197,    32,   308,  -394,   269,   285,   221,   115,  -394,
    -394,  -394,   269,   223,   177,  -394,   296,   191,  -394,  -394,
     191,   313,   296,   200,   227,   262,  -394,   190,    43,  -394,
    -394,  -394,  -394,  -394,   177,   315,  -394,   284,  -394,   242,
     243,   204,  -394,   197,   213,   296,  -394,  -394,  -394,  -394,
    -394,   201,  -394,   195,  -394,   206,   269,  -394,   207,  -394,
       6,  -394,   324,  -394,   269,     2,  -394,   269,   285,   324,
     285,    59,  -394,    16,  -394,   210,   219,   211,   208,  -394,
    -394,  -394,   212,  -394,   215,   227,   107,  -394,  -394,   216,
    -394,  -394,  -394,  -394,  -394,   296,  -394,  -394,  -394,  -394,
     263,   -52,   107,    32,   269,    32,   333,   192,  -394,   194,
    -394,   285,  -394,   230,   217,   225,  -394,  -394,   324,  -394,
     324,  -394,   115,  -394,  -394,    22,   261,    46,  -394,  -394,
     296,   220,   223,  -394,   271,   -46,   204,    48,   224,  -394,
      38,  -394,  -394,  -394,   223,  -394,   218,   269,  -394,  -394,
    -394,   306,  -394,   307,  -394,   192,  -394,  -394,   296,  -394,
     296,  -394,  -394,   222,   222,  -394,   317,  -394,    13,  -394,
    -394,  -394,   192,   192,  -394,   225,  -394,  -394,  -394,  -394,
    -394,   230,   230,  -394,  -394,  -394,  -394,  -394,   344,  -394,
     231,  -394,  -394,  -394,   232,   236,   296,   219,   346,    18,
     347,   347,  -394,  -394,    90,    90,   271,  -394,   224,  -394,
     219,  -394,  -394,  -394,  -394,  -394,   238,   238,   349,  -394,
    -394,    22,   319,  -394,   296,   296,   296,   296,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,   239,   261,  -394,  -394,  -394,
    -394,  -394,   198,  -394,  -394,  -394,  -394,  -394,  -394,   204,
     204,    18,  -394,   261,   296,   240,  -394,  -394,   241,   238,
     238,   238,   238,  -394,  -394,   290,  -394,    10,  -394,   250,
     252,   293,  -394,  -394,  -394,  -394,   295,    10,    10,   122,
     348,   297,  -394,   298,  -394,  -394,  -394,  -394,    10,  -394,
    -394,    -4,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
      25,   269,   204,    10,    10,   348,  -394,   248,  -394,  -394,
     255,  -394,  -394,  -394,   257,   258,  -394,  -394,   204,   269,
    -394,   259,  -394,  -394
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -394,  -394,  -394,  -394,   -22,  -394,   354,  -394,  -394,  -394,
    -394,   244,  -144,  -394,  -394,  -165,  -394,    21,  -394,  -394,
    -394,  -394,    36,  -394,   -91,  -230,  -394,   -89,  -394,  -394,
     124,  -156,  -394,  -394,    12,  -394,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,     7,   -58,  -394,
      83,  -118,  -192,  -394,  -394,  -394,    71,   -96,  -336,  -394,
    -394,   -57,  -394,  -394,  -394,  -394,   -41,   299,  -137,  -394,
     -93,  -394,   184,  -186,  -250,  -292,  -394,  -394,  -394,  -394,
    -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,  -394,
    -394,     8,   -79,    93,  -127,  -394,    96,  -229,   -85,   -20,
    -394,  -107,  -394,  -394,    97,  -394,  -394,    -3,   117,  -394,
    -394,  -394,  -394,  -119,  -394,  -394,  -394,  -394,  -394,   -98,
    -394,  -394,  -394,   214,    70,  -394,  -394,     1,   -92,   -42,
    -394,   -78,   -67,  -214,   -65,  -394,  -394,  -394,  -394,  -394,
    -393,  -265,  -394,  -394,     9,  -394,   -90,  -394,  -394,  -394,
    -394,    17
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -235
static const short yytable[] =
{
     124,   185,   151,   187,    90,   108,   306,   256,   192,    63,
      75,    81,   403,   123,   371,    89,   193,   365,   203,   123,
     169,   164,   119,   121,   304,   364,   365,   366,   487,   365,
     488,   132,   250,   166,   243,   244,   228,   450,   171,     1,
       2,     3,     4,     5,     6,     7,   184,     8,     9,   184,
     210,   184,   258,   387,   227,   389,   118,   299,   262,   483,
     140,    88,    61,   181,   268,   419,   380,   317,   149,   381,
     128,   288,    88,    61,   155,   457,   156,   420,   421,   318,
     206,   284,   297,   367,    10,    91,   167,   216,   266,   495,
      86,   267,   367,   217,   372,   367,   282,   264,   304,   223,
     238,   257,   229,    86,   133,   501,   361,   255,   362,   141,
     397,    11,    95,   165,   384,   385,    94,   150,   218,   163,
     486,   270,   295,   432,   444,   248,   377,   416,   290,   312,
     298,   314,   300,   458,   291,   168,   303,   426,   390,   259,
     433,   452,   260,   368,   489,   324,   250,   243,   249,   427,
     428,   238,   368,    96,    53,   368,    97,   317,   311,   294,
      54,   205,   238,   373,   101,   197,   375,   104,   255,   388,
      65,    66,    99,   386,   439,   440,   441,   442,    55,    56,
      78,   301,    57,    60,    61,   102,    65,   302,    55,    56,
      67,   138,   139,    68,   105,    69,    70,   341,   107,   255,
      71,    55,    56,   111,    55,    56,    55,    56,    79,  -205,
      69,    70,   109,    82,    83,    84,    86,   112,   342,   343,
     113,   344,   345,    72,    73,   115,   330,   331,  -145,   332,
     333,   114,   415,   472,   473,   474,   475,   476,   477,   478,
     479,   122,   255,   211,   212,   213,    62,    74,    80,   198,
     199,   219,   220,   243,   244,   138,   139,   352,   353,   445,
     446,   404,   406,   405,   407,   409,   410,   190,   191,   496,
     497,   120,   123,   117,   127,   129,   126,   131,   136,   144,
     160,   154,   146,   148,   158,   159,   145,   147,   172,   175,
     453,   176,   178,   179,   152,   162,   182,   183,   133,   184,
     186,   188,   194,   195,   189,   207,   196,   201,   202,   208,
     204,   221,   233,   215,   224,   239,   225,   261,   265,   271,
     263,   273,   274,   275,   283,   286,   287,   292,   308,   285,
     307,   315,   309,   289,   310,   305,   313,   329,   391,   376,
     378,   348,   392,   317,   351,   398,   393,   401,   411,   417,
     437,   423,   413,   435,   456,   467,   414,   469,   412,   443,
     483,   481,   484,    93,   454,   400,   434,   408,   455,   296,
     465,   394,   466,   363,   347,   116,   325,  -234,   500,   503,
     327,   436,   328,   494,   499,   165,   383,   431,   490,   451,
     485,   471,   470,     0,   430,   498,   124,     0,   425,     0,
       0,   272,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   502,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278
};

static const short yycheck[] =
{
      85,   145,   109,   147,     7,    63,   256,   193,   152,     2,
       3,     4,   348,     3,   306,     7,   153,     4,   162,     3,
     127,    36,    79,    81,   253,     3,     4,     5,     3,     4,
       5,    48,   188,   126,    32,    33,     4,   430,   131,     9,
      10,    11,    12,    13,    14,    15,     3,    17,    18,     3,
     169,     3,   196,   318,   181,   320,    78,   249,   202,    63,
     101,    22,    23,   142,   208,    47,   112,   119,   109,   115,
      92,   236,    22,    23,    20,    65,    22,    59,    60,   131,
     165,   225,   247,    70,    54,    16,   127,   122,   207,   482,
      53,    48,    70,   128,    48,    70,   223,   204,   327,   178,
     185,   194,    70,    53,   121,   498,   298,   192,   300,   101,
     340,    81,     0,   128,    66,    67,    82,   109,   175,   122,
     124,   214,   120,   388,   416,    10,   312,   377,   122,   266,
     248,   275,   250,   123,   128,   127,   120,    47,   324,   197,
     390,   433,   200,   130,   480,   282,   302,    32,    33,    59,
      60,   236,   130,    71,    16,   130,    49,   119,   265,   244,
      22,   164,   247,   307,    36,   158,   310,    20,   253,   131,
      22,    23,     3,   317,   404,   405,   406,   407,    40,    41,
      16,   122,    44,    22,    23,     3,    22,   128,    40,    41,
      42,    28,    29,    45,     3,    47,    48,     3,    20,   284,
      52,    40,    41,    57,    40,    41,    40,    41,    44,    39,
      47,    48,    39,    51,    52,    53,    53,    36,    24,    25,
      21,    27,    28,    75,    76,    23,    34,    35,    80,    37,
      38,    43,   376,   111,   112,   113,   114,   115,   116,   117,
     118,    36,   327,    84,    85,    86,     2,     3,     4,    40,
      41,    77,    78,    32,    33,    28,    29,    32,    33,    61,
      62,   352,   353,   352,   353,   361,   362,   150,   151,   483,
     484,    20,     3,    80,    39,    19,   111,    74,    55,    46,
      54,    53,   111,   111,    55,    36,   119,   119,     4,    44,
     434,    72,    58,    56,   119,   119,   111,   111,   121,     3,
     121,   121,    49,    20,    58,    58,   119,   111,   119,   119,
      56,    50,     4,   130,    28,    30,   119,     4,    56,     4,
     120,    79,    79,   119,   111,   130,   120,     3,   120,   128,
     119,    68,   120,   126,   119,   125,   120,     4,   120,   119,
      69,   111,    36,   119,   127,   123,    39,    30,     4,     3,
      31,     4,   120,     4,    64,    62,   120,    62,   127,   120,
      63,    13,    64,     9,   124,   344,   128,   355,   127,   245,
     120,   335,   120,   302,   291,    76,   283,   129,   120,   120,
     284,   401,   285,   481,   129,   128,   316,   386,   480,   431,
     468,   458,   457,    -1,   385,   485,   481,    -1,   381,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short yystos[] =
{
       0,     9,    10,    11,    12,    13,    14,    15,    17,    18,
      54,    81,   135,   136,   137,   139,   141,   142,   144,   162,
     173,   174,   175,   176,   177,   180,   188,   193,   194,   197,
     198,   199,   210,   212,   214,   215,   217,   218,   220,   221,
     222,   223,   224,   234,   239,   240,   243,   244,   246,   249,
     250,   251,   254,    16,    22,    40,    41,    44,   145,   181,
      22,    23,   145,   181,   241,    22,    23,    42,    45,    47,
      48,    52,    75,    76,   145,   181,   200,   201,    16,    44,
     145,   181,    51,    52,    53,   252,    53,   225,    22,   225,
     241,    16,   140,   140,    82,     0,    71,    49,   202,     3,
     138,    36,     3,   195,    20,     3,   182,    20,   182,    39,
     245,    57,    36,    21,    43,    23,   201,    80,   138,   195,
      20,   182,    36,     3,   232,   253,   111,    39,   138,    19,
     143,    74,    48,   121,   203,   204,    55,   207,    28,    29,
     200,   225,   235,   236,    46,   119,   111,   119,   111,   200,
     225,   235,   119,   242,    53,    20,    22,   216,    55,    36,
      54,   211,   119,   241,    36,   128,   204,   200,   225,   235,
     178,   204,     4,   205,   206,    44,    72,   208,    58,    56,
     226,   226,   111,   111,     3,   146,   121,   146,   121,    58,
     242,   242,   146,   202,    49,    20,   119,   181,    40,    41,
     219,   111,   119,   146,    56,   241,   232,    58,   119,   247,
     247,    84,    85,    86,   179,   130,   122,   128,   195,    77,
      78,    50,   209,   226,    28,   119,   228,   228,     4,    70,
     227,   237,   238,     4,   196,   147,   148,   149,   232,    30,
     183,   184,   185,    32,    33,   163,   164,   165,    10,    33,
     165,   189,   190,   230,   231,   232,   207,   204,   146,   182,
     182,     4,   146,   120,   235,    56,   247,    48,   146,   248,
     204,     4,   206,    79,    79,   119,   255,   256,   257,   258,
     259,   260,   228,   111,   146,   128,   130,   120,   149,   126,
     122,   128,     3,   186,   232,   120,   164,   149,   185,   186,
     185,   122,   128,   120,   231,   125,   208,   119,   120,   120,
     119,   235,   202,   120,   146,    68,   283,   119,   131,   275,
     276,   277,   279,   281,   202,   227,   229,   230,   238,     4,
      34,    35,    37,    38,   154,   155,   156,   157,   158,   160,
     161,     3,    24,    25,    27,    28,   150,   184,   111,   187,
     191,   127,    32,    33,   166,   167,   168,   169,   170,   171,
     172,   186,   186,   190,     3,     4,     5,    70,   130,   192,
     233,   209,    48,   146,   213,   146,   119,   207,    69,   261,
     112,   115,   284,   258,    66,    67,   146,   275,   131,   275,
     207,   120,    36,    39,   156,   146,   159,   159,   123,   151,
     151,    30,   152,   192,   158,   161,   158,   161,   168,   191,
     191,     4,   127,   120,   120,   146,   208,     3,   262,    47,
      59,    60,   263,     4,   285,   285,    47,    59,    60,   278,
     278,   261,   275,   208,   128,     4,   233,    31,   153,   159,
     159,   159,   159,   120,   209,    61,    62,   264,   257,   274,
     274,   263,   209,   146,   124,   127,    64,    65,   123,   232,
     265,   266,   267,   268,   269,   120,   120,    62,   282,    62,
     268,   266,   111,   112,   113,   114,   115,   116,   117,   118,
     270,    13,   280,    63,    64,   265,   124,     3,     5,   192,
     262,   271,   272,   273,   253,   274,   267,   267,   280,   129,
     120,   274,   232,   120
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval; yylval.pBlocks = 0; /* Initalize yylval to dummy value. */

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 423 "mql.yxx"
    { ((CMQL_execution_environment*) parm)->pStatement = yyvsp[-1].pStatement; ;}
    break;

  case 41:
#line 468 "mql.yxx"
    { yyval.pStatement = new CCreateDatabaseStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 42:
#line 472 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 43:
#line 476 "mql.yxx"
    { yyval.pStatement = new CUseStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 46:
#line 484 "mql.yxx"
    { yyval.pStatement = new CDropDatabaseStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 47:
#line 489 "mql.yxx"
    { yyval.pStatement = new CVacuumDatabaseStatement((CMQL_execution_environment*) parm, yyvsp[0].boolean); ;}
    break;

  case 48:
#line 493 "mql.yxx"
    { yyval.boolean = false; ;}
    break;

  case 49:
#line 495 "mql.yxx"
    { yyval.boolean = true; ;}
    break;

  case 50:
#line 503 "mql.yxx"
    { yyval.pStatement = new CCreateObjectTypeStatement((CMQL_execution_environment*) parm, yyvsp[-3].pString, yyvsp[-2].pFeatureDeclaration, yyvsp[0].pCBBFList); ;}
    break;

  case 53:
#line 510 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 54:
#line 514 "mql.yxx"
    { yyval.pFeatureDeclaration = yyvsp[0].pFeatureDeclaration; ;}
    break;

  case 55:
#line 516 "mql.yxx"
    { yyval.pFeatureDeclaration = 0; ;}
    break;

  case 56:
#line 520 "mql.yxx"
    { yyval.pFeatureDeclaration = yyvsp[0].pFeatureDeclaration; ;}
    break;

  case 57:
#line 522 "mql.yxx"
    { yyval.pFeatureDeclaration = yyvsp[0].pFeatureDeclaration; yyval.pFeatureDeclaration->set_Next(yyvsp[-1].pFeatureDeclaration); ;}
    break;

  case 58:
#line 527 "mql.yxx"
    { yyval.pFeatureDeclaration = new CFeatureDeclaration(yyvsp[-5].pString, yyvsp[-3].pType, yyvsp[-2].pExpression, yyvsp[-1].boolean, 0); ;}
    break;

  case 59:
#line 531 "mql.yxx"
    { yyval.pType = new CType(kInteger); ;}
    break;

  case 60:
#line 533 "mql.yxx"
    { yyval.pType = new CType(kString, 2*yyvsp[0].integer); ;}
    break;

  case 61:
#line 535 "mql.yxx"
    { yyval.pType = new CType(kASCII, yyvsp[0].integer); ;}
    break;

  case 62:
#line 537 "mql.yxx"
    { yyval.pType = new CType(kID_D); ;}
    break;

  case 63:
#line 539 "mql.yxx"
    { yyval.pType = new CType(yyvsp[0].pString); ;}
    break;

  case 64:
#line 543 "mql.yxx"
    { yyval.integer = MAX_STRING_LENGTH; ;}
    break;

  case 65:
#line 545 "mql.yxx"
    { yyval.integer = yyvsp[-1].integer; ;}
    break;

  case 66:
#line 549 "mql.yxx"
    { yyval.pExpression = yyvsp[0].pExpression; ;}
    break;

  case 67:
#line 551 "mql.yxx"
    { yyval.pExpression = 0; ;}
    break;

  case 68:
#line 555 "mql.yxx"
    { yyval.boolean = true; ;}
    break;

  case 69:
#line 557 "mql.yxx"
    { yyval.boolean = false; ;}
    break;

  case 70:
#line 562 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 71:
#line 564 "mql.yxx"
    { yyval.pCBBFList = 0; ;}
    break;

  case 72:
#line 568 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 73:
#line 570 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; yyval.pCBBFList->set_Next(yyvsp[-1].pCBBFList); ;}
    break;

  case 74:
#line 574 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 75:
#line 576 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 76:
#line 582 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kAdd, kBuildable_from, 0); ;}
    break;

  case 79:
#line 590 "mql.yxx"
    { yyval.pObjectTypeName = new CObjectTypeName(yyvsp[0].pString, 0); ;}
    break;

  case 80:
#line 592 "mql.yxx"
    { yyval.pObjectTypeName = new CObjectTypeName(yyvsp[0].pString, yyvsp[-2].pObjectTypeName); ;}
    break;

  case 81:
#line 597 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kAdd, kCovered_by, 0); ;}
    break;

  case 84:
#line 609 "mql.yxx"
    { yyval.pStatement = new CUpdateObjectTypeStatement((CMQL_execution_environment*) parm, yyvsp[-3].pString, yyvsp[-2].pFeatureUpdate, yyvsp[0].pCBBFList); ;}
    break;

  case 85:
#line 613 "mql.yxx"
    { yyval.pFeatureUpdate = yyvsp[0].pFeatureUpdate; ;}
    break;

  case 86:
#line 615 "mql.yxx"
    { yyval.pFeatureUpdate = yyvsp[0].pFeatureUpdate; yyval.pFeatureUpdate->set_Next(yyvsp[-1].pFeatureUpdate); ;}
    break;

  case 87:
#line 619 "mql.yxx"
    { yyval.pFeatureUpdate = new CFeatureUpdate(yyvsp[0].pFeatureDeclaration, 0); ;}
    break;

  case 88:
#line 621 "mql.yxx"
    { yyval.pFeatureUpdate = new CFeatureUpdate(yyvsp[-1].pString, 0); ;}
    break;

  case 91:
#line 628 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 92:
#line 630 "mql.yxx"
    { yyval.pCBBFList = 0; ;}
    break;

  case 93:
#line 634 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; ;}
    break;

  case 94:
#line 636 "mql.yxx"
    { yyval.pCBBFList = yyvsp[0].pCBBFList; yyval.pCBBFList->set_Next(yyvsp[-1].pCBBFList); ;}
    break;

  case 99:
#line 647 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kAdd, kCovered_by, 0); ;}
    break;

  case 100:
#line 652 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kRemove, kCovered_by, 0); ;}
    break;

  case 101:
#line 657 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kAdd, kBuildable_from, 0); ;}
    break;

  case 102:
#line 662 "mql.yxx"
    { yyval.pCBBFList = new CCBBFList(yyvsp[0].pObjectTypeName, kRemove, kBuildable_from, 0); ;}
    break;

  case 103:
#line 668 "mql.yxx"
    { yyval.pStatement = new CDropObjectTypeStatement((CMQL_execution_environment*) parm, yyvsp[-1].pString); ;}
    break;

  case 104:
#line 672 "mql.yxx"
    { yyval.pStatement = new CInsertMonadsStatement((CMQL_execution_environment*) parm, yyvsp[0].pMonadSetElement); ;}
    break;

  case 105:
#line 676 "mql.yxx"
    { yyval.pStatement = new CDeleteMonadsStatement((CMQL_execution_environment*) parm, yyvsp[0].pMonadSetElement); ;}
    break;

  case 106:
#line 683 "mql.yxx"
    { yyval.pStatement = new CGetMonadsStatement((CMQL_execution_environment*) parm, yyvsp[-3].pID_D, yyvsp[-1].pString); ;}
    break;

  case 107:
#line 689 "mql.yxx"
    { yyval.pStatement = new CMonadSetCalculationStatement((CMQL_execution_environment*) parm, yyvsp[0].pMonadSetChainElement); ;}
    break;

  case 108:
#line 693 "mql.yxx"
    { yyval.pMonadSetChainElement = new CMonadSetChainElement(yyvsp[0].pMonadSetElement, kSONone, 0); ;}
    break;

  case 109:
#line 695 "mql.yxx"
    { yyval.pMonadSetChainElement = new CMonadSetChainElement(yyvsp[0].pMonadSetElement, yyvsp[-1].set_operator, 0); yyval.pMonadSetChainElement->set_Next(yyvsp[-2].pMonadSetChainElement); ;}
    break;

  case 110:
#line 699 "mql.yxx"
    { yyval.set_operator = kSOUnion; ;}
    break;

  case 111:
#line 701 "mql.yxx"
    { yyval.set_operator = kSODifference; ;}
    break;

  case 112:
#line 703 "mql.yxx"
    { yyval.set_operator = kSOIntersect; ;}
    break;

  case 113:
#line 710 "mql.yxx"
    { yyval.pStatement = new CCreateEnumerationStatement((CMQL_execution_environment*) parm, yyvsp[-4].pString, yyvsp[-1].pECDeclaration); ;}
    break;

  case 114:
#line 714 "mql.yxx"
    { yyval.boolean = false; ;}
    break;

  case 115:
#line 716 "mql.yxx"
    { yyval.boolean = false; ;}
    break;

  case 116:
#line 720 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 117:
#line 724 "mql.yxx"
    { yyval.pECDeclaration = yyvsp[0].pECDeclaration; ;}
    break;

  case 118:
#line 726 "mql.yxx"
    { yyval.pECDeclaration = yyvsp[0].pECDeclaration; yyval.pECDeclaration->set_Next(yyvsp[-2].pECDeclaration); ;}
    break;

  case 119:
#line 730 "mql.yxx"
    { yyval.pECDeclaration = new CECDeclaration(yyvsp[-2].boolean, yyvsp[-1].pString, yyvsp[0].pLong, 0); ;}
    break;

  case 120:
#line 734 "mql.yxx"
    { yyval.boolean = true; ;}
    break;

  case 121:
#line 736 "mql.yxx"
    { yyval.boolean = false; ;}
    break;

  case 122:
#line 740 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 123:
#line 744 "mql.yxx"
    { yyval.pLong = new long(yyvsp[0].integer); ;}
    break;

  case 124:
#line 747 "mql.yxx"
    { yyval.pLong = 0; ;}
    break;

  case 125:
#line 753 "mql.yxx"
    { yyval.pStatement = new CUpdateEnumerationStatement((CMQL_execution_environment*) parm, yyvsp[-4].pString, yyvsp[-1].pECUpdate); ;}
    break;

  case 126:
#line 757 "mql.yxx"
    { yyval.pECUpdate = yyvsp[0].pECUpdate; ;}
    break;

  case 127:
#line 759 "mql.yxx"
    { yyval.pECUpdate = yyvsp[0].pECUpdate; yyval.pECUpdate->set_Next(yyvsp[-2].pECUpdate); ;}
    break;

  case 128:
#line 764 "mql.yxx"
    { yyval.pECUpdate = new CECUpdate(yyvsp[-2].boolean, yyvsp[-1].pString, yyvsp[0].integer, kAdd, 0); ;}
    break;

  case 129:
#line 766 "mql.yxx"
    { yyval.pECUpdate = new CECUpdate(yyvsp[-2].boolean, yyvsp[-1].pString, yyvsp[0].integer, kUpdate, 0); ;}
    break;

  case 130:
#line 768 "mql.yxx"
    { yyval.pECUpdate = new CECUpdate(false, yyvsp[0].pString, 0, kRemove, 0); ;}
    break;

  case 131:
#line 772 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 132:
#line 776 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 133:
#line 778 "mql.yxx"
    { yyval.integer = -yyvsp[0].integer; ;}
    break;

  case 134:
#line 780 "mql.yxx"
    { yyval.integer = NIL; ;}
    break;

  case 135:
#line 785 "mql.yxx"
    { yyval.pStatement = new CDropEnumerationStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 136:
#line 792 "mql.yxx"
    { yyval.pStatement = new CCreateSegmentStatement((CMQL_execution_environment*) parm, yyvsp[-3].pString, yyvsp[0].pMonadSetElement); ;}
    break;

  case 137:
#line 796 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 138:
#line 800 "mql.yxx"
    { yyval.pMonadSetElement = new CMonadSetElement(yyvsp[-2].integer, yyvsp[0].integer, 0); ;}
    break;

  case 139:
#line 805 "mql.yxx"
    { yyval.pStatement = new CDropSegmentStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 140:
#line 813 "mql.yxx"
    { yyval.pStatement = new CSelectStatement((CMQL_execution_environment*) parm, yyvsp[-4].focus, yyvsp[-3].pMonadSetElement, yyvsp[-2].pString, yyvsp[-1].sheaf_return_type, yyvsp[0].pTopograph); ;}
    break;

  case 141:
#line 817 "mql.yxx"
    { yyval.focus = yyvsp[-1].focus; ;}
    break;

  case 142:
#line 821 "mql.yxx"
    { yyval.focus = kFocus; ;}
    break;

  case 143:
#line 823 "mql.yxx"
    { yyval.focus = kAll; ;}
    break;

  case 146:
#line 831 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[0].pMonadSetElement; ;}
    break;

  case 147:
#line 833 "mql.yxx"
    { yyval.pMonadSetElement = new CMonadSetElement(1L, MAX_MONAD, 0); ;}
    break;

  case 148:
#line 837 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[0].pMonadSetElement; ;}
    break;

  case 149:
#line 839 "mql.yxx"
    { yyval.pMonadSetElement = new CMonadSetElement(1L, MAX_MONAD, 0); ;}
    break;

  case 150:
#line 843 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[-1].pMonadSetElement; ;}
    break;

  case 151:
#line 847 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[0].pMonadSetElement; ;}
    break;

  case 152:
#line 849 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[0].pMonadSetElement; yyval.pMonadSetElement->set_Next(yyvsp[-2].pMonadSetElement); ;}
    break;

  case 153:
#line 853 "mql.yxx"
    { yyval.pMonadSetElement = new CMonadSetElement(yyvsp[0].integer, 0); ;}
    break;

  case 154:
#line 855 "mql.yxx"
    { yyval.pMonadSetElement = new CMonadSetElement(yyvsp[-2].integer, yyvsp[0].integer, 0); ;}
    break;

  case 155:
#line 859 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 156:
#line 861 "mql.yxx"
    { yyval.pString = 0; ;}
    break;

  case 157:
#line 865 "mql.yxx"
    { yyval.sheaf_return_type = kFullSheaf; ;}
    break;

  case 158:
#line 867 "mql.yxx"
    { yyval.sheaf_return_type = kFullSheaf; ;}
    break;

  case 159:
#line 869 "mql.yxx"
    { yyval.sheaf_return_type = kFlatSheaf; ;}
    break;

  case 160:
#line 873 "mql.yxx"
    { yyval.pTopograph = yyvsp[0].pTopograph; ;}
    break;

  case 161:
#line 881 "mql.yxx"
    { yyval.pStatement = new CSelectObjectsAtStatement((CMQL_execution_environment*) parm, yyvsp[-3].integer, yyvsp[-1].pString); ;}
    break;

  case 162:
#line 886 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 163:
#line 895 "mql.yxx"
    { yyval.pStatement = new CSelectObjectsHavingMonadsInStatement((CMQL_execution_environment*) parm, yyvsp[-3].pMonadSetElement, yyvsp[-1].pString); ;}
    break;

  case 164:
#line 899 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 165:
#line 901 "mql.yxx"
    { yyval.pString = new std::string("all"); ;}
    break;

  case 166:
#line 906 "mql.yxx"
    { yyval.pStatement = new CSelectObjectTypesStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 167:
#line 912 "mql.yxx"
    { yyval.pStatement = new CSelectFeaturesStatement((CMQL_execution_environment*) parm, yyvsp[-1].pString); ;}
    break;

  case 171:
#line 922 "mql.yxx"
    { yyval.pStatement = new CSelectEnumerationsStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 172:
#line 929 "mql.yxx"
    { yyval.pStatement = new CSelectEnumerationConstantsStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 176:
#line 941 "mql.yxx"
    { yyval.pStatement = new CSelectObjectTypesUsingEnumerationStatement((CMQL_execution_environment*) parm, yyvsp[0].pString); ;}
    break;

  case 177:
#line 945 "mql.yxx"
    { yyval.pStatement = new CSelectSegmentsStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 178:
#line 949 "mql.yxx"
    { yyval.pStatement = new CSelectMinMStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 179:
#line 953 "mql.yxx"
    { yyval.pStatement = new CSelectMaxMStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 180:
#line 960 "mql.yxx"
    { yyval.pStatement = new CCreateObjectFromMonadsStatement((CMQL_execution_environment*) parm, yyvsp[-2].pMonadSetElement, yyvsp[-1].integer, yyvsp[0].pObjectSpec); ;}
    break;

  case 181:
#line 964 "mql.yxx"
    { yyval.pMonadSetElement = yyvsp[0].pMonadSetElement; ;}
    break;

  case 182:
#line 968 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 183:
#line 970 "mql.yxx"
    { yyval.integer = NIL; ;}
    break;

  case 184:
#line 974 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 185:
#line 976 "mql.yxx"
    { yyval.integer = NIL; ;}
    break;

  case 186:
#line 983 "mql.yxx"
    { yyval.pObjectSpec = new CObjectSpec(yyvsp[-2].pString, yyvsp[-1].pFeatureAssignment); ;}
    break;

  case 187:
#line 987 "mql.yxx"
    { yyval.pFeatureAssignment = yyvsp[0].pFeatureAssignment; ;}
    break;

  case 188:
#line 989 "mql.yxx"
    { yyval.pFeatureAssignment = 0; ;}
    break;

  case 189:
#line 993 "mql.yxx"
    { yyval.pFeatureAssignment = yyvsp[0].pFeatureAssignment; ;}
    break;

  case 190:
#line 995 "mql.yxx"
    { yyval.pFeatureAssignment = yyvsp[0].pFeatureAssignment; yyval.pFeatureAssignment->set_Next(yyvsp[-1].pFeatureAssignment); ;}
    break;

  case 191:
#line 999 "mql.yxx"
    { yyval.pFeatureAssignment = new CFeatureAssignment(yyvsp[-3].pString, yyvsp[-1].pExpression, 0); ;}
    break;

  case 192:
#line 1003 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 193:
#line 1007 "mql.yxx"
    { yyval.pExpression = new CExpression(yyvsp[0].integer); ;}
    break;

  case 194:
#line 1009 "mql.yxx"
    { yyval.pExpression = new CExpression(yyvsp[0].pString, kExprString); ;}
    break;

  case 195:
#line 1011 "mql.yxx"
    { yyval.pExpression = new CExpression(yyvsp[0].pString, kExprIdentifier); ;}
    break;

  case 196:
#line 1018 "mql.yxx"
    { yyval.pStatement = new CCreateObjectFromID_DsStatement((CMQL_execution_environment*) parm, yyvsp[-2].pID_D, yyvsp[-1].integer, yyvsp[0].pObjectSpec); ;}
    break;

  case 197:
#line 1022 "mql.yxx"
    { yyval.pID_D = yyvsp[0].pID_D; ;}
    break;

  case 200:
#line 1030 "mql.yxx"
    { yyval.pID_D = yyvsp[0].pID_D; ;}
    break;

  case 201:
#line 1032 "mql.yxx"
    { yyval.pID_D = yyvsp[0].pID_D; yyval.pID_D->set_Next(yyvsp[-2].pID_D); ;}
    break;

  case 202:
#line 1036 "mql.yxx"
    { yyval.pID_D = new CID_D(yyvsp[0].integer, 0); ;}
    break;

  case 203:
#line 1047 "mql.yxx"
    { yyval.pStatement = new CCreateObjectFromQueryStatement((CMQL_execution_environment*) parm, yyvsp[-7].focus, yyvsp[-5].integer, yyvsp[-4].pObjectSpec, yyvsp[-3].pMonadSetElement, yyvsp[-2].pString, yyvsp[-1].sheaf_return_type, yyvsp[0].pTopograph); ;}
    break;

  case 204:
#line 1055 "mql.yxx"
    { yyval.pStatement = new CUpdateObjectsByMonadsStatement((CMQL_execution_environment*) parm, yyvsp[-1].pMonadSetElement, yyvsp[0].pObjectSpec); ;}
    break;

  case 207:
#line 1065 "mql.yxx"
    { yyval.pObjectSpec = new CObjectSpec(yyvsp[-2].pString, yyvsp[-1].pFeatureAssignment); ;}
    break;

  case 208:
#line 1073 "mql.yxx"
    { yyval.pStatement = new CUpdateObjectsByID_DsStatement((CMQL_execution_environment*) parm, yyvsp[-1].pID_D, yyvsp[0].pObjectSpec); ;}
    break;

  case 209:
#line 1085 "mql.yxx"
    { yyval.pStatement = new CUpdateObjectsByQueryStatement((CMQL_execution_environment*) parm, yyvsp[-5].focus, yyvsp[-4].pObjectSpec, yyvsp[-3].pMonadSetElement, yyvsp[-2].pString, yyvsp[-1].sheaf_return_type, yyvsp[0].pTopograph); ;}
    break;

  case 210:
#line 1090 "mql.yxx"
    { yyval.focus = yyvsp[-1].focus; ;}
    break;

  case 211:
#line 1097 "mql.yxx"
    { yyval.pStatement = new CDeleteObjectsByMonadsStatement((CMQL_execution_environment*) parm, yyvsp[-1].pMonadSetElement, yyvsp[0].pString); ;}
    break;

  case 212:
#line 1103 "mql.yxx"
    { yyval.pString = yyvsp[-1].pString; ;}
    break;

  case 213:
#line 1107 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 214:
#line 1109 "mql.yxx"
    { yyval.pString = new std::string("all"); ;}
    break;

  case 215:
#line 1117 "mql.yxx"
    { yyval.pStatement = new CDeleteObjectsByID_DsStatement((CMQL_execution_environment*) parm, yyvsp[-1].pID_D, yyvsp[0].pString); ;}
    break;

  case 216:
#line 1129 "mql.yxx"
    { yyval.pStatement = new CDeleteObjectsByQueryStatement((CMQL_execution_environment*) parm, yyvsp[-6].focus, yyvsp[-4].pString, yyvsp[-3].pMonadSetElement, yyvsp[-2].pString, yyvsp[-1].sheaf_return_type, yyvsp[0].pTopograph); ;}
    break;

  case 217:
#line 1141 "mql.yxx"
    { yyval.pStatement = new CGetFeaturesStatement((CMQL_execution_environment*) parm, yyvsp[-7].pFeature, yyvsp[-3].pID_D, yyvsp[-1].pString); ;}
    break;

  case 220:
#line 1149 "mql.yxx"
    { yyval.pFeature = new CFeature(yyvsp[0].pString, 0); ;}
    break;

  case 221:
#line 1151 "mql.yxx"
    { yyval.pFeature = new CFeature(yyvsp[0].pString, yyvsp[-2].pFeature); ;}
    break;

  case 222:
#line 1155 "mql.yxx"
    { yyval.pStatement = new CQuitStatement((CMQL_execution_environment*) parm); ;}
    break;

  case 223:
#line 1159 "mql.yxx"
    { yyval.pTopograph = yyvsp[0].pTopograph; ;}
    break;

  case 224:
#line 1163 "mql.yxx"
    { yyval.pTopograph = new CTopograph(yyvsp[0].pBlocks); ;}
    break;

  case 225:
#line 1167 "mql.yxx"
    { yyval.pBlocks = new CBlocks(yyvsp[0].pBlock_string); ;}
    break;

  case 226:
#line 1171 "mql.yxx"
    { yyval.pBlock_string = new CBlock_string(yyvsp[0].pBlock_str); ;}
    break;

  case 227:
#line 1173 "mql.yxx"
    { yyval.pBlock_string = new CBlock_string(yyvsp[-2].pBlock_str, yyvsp[-1].pPower, yyvsp[0].pBlock_string); ;}
    break;

  case 228:
#line 1177 "mql.yxx"
    { yyval.pBlock_str = new CBlock_str(yyvsp[0].pObject_block_first); ;}
    break;

  case 229:
#line 1179 "mql.yxx"
    { yyval.pBlock_str = new CBlock_str(yyvsp[-2].pObject_block_first, yyvsp[0].pRest_of_block_str); ;}
    break;

  case 230:
#line 1181 "mql.yxx"
    { if (yyvsp[0].pRest_of_block_str->get_block()->is_gap_or_opt_gap_block()) {
        yyval.pBlock_str = new CBlock_str(yyvsp[-1].pObject_block_first, yyvsp[0].pRest_of_block_str);
      } else {
	COpt_gap_block* pOGB = new COpt_gap_block(kNoRetrieve, 0);
	CBlock* pB = new CBlock(pOGB);
	CRest_of_block_str* pROBS = new CRest_of_block_str(pB, yyvsp[0].pRest_of_block_str);
	yyval.pBlock_str = new CBlock_str(yyvsp[-1].pObject_block_first, pROBS);
      }
    ;}
    break;

  case 231:
#line 1198 "mql.yxx"
    { yyval.pObject_block_first = new CObject_block_first(yyvsp[-7].pString, yyvsp[-6].pString, yyvsp[-5].retrieval, yyvsp[-4].firstlast, yyvsp[-3].pFFeatures, yyvsp[-2].pFeature, yyvsp[-1].pBlocks); ;}
    break;

  case 232:
#line 1202 "mql.yxx"
    { yyval.pString = new std::string(""); ;}
    break;

  case 233:
#line 1204 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 234:
#line 1208 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 235:
#line 1212 "mql.yxx"
    { yyval.retrieval = kRetrieve; ;}
    break;

  case 236:
#line 1214 "mql.yxx"
    { yyval.retrieval = kNoRetrieve; ;}
    break;

  case 237:
#line 1216 "mql.yxx"
    { yyval.retrieval = kRetrieve; ;}
    break;

  case 238:
#line 1218 "mql.yxx"
    { yyval.retrieval = kRetrieveFocus; ;}
    break;

  case 239:
#line 1222 "mql.yxx"
    { yyval.firstlast = kNoFirstLast; ;}
    break;

  case 240:
#line 1224 "mql.yxx"
    { yyval.firstlast = kFirst; ;}
    break;

  case 241:
#line 1226 "mql.yxx"
    { yyval.firstlast = kLast; ;}
    break;

  case 242:
#line 1228 "mql.yxx"
    { yyval.firstlast = kFirstAndLast; ;}
    break;

  case 243:
#line 1232 "mql.yxx"
    { yyval.pFFeatures = 0; ;}
    break;

  case 244:
#line 1234 "mql.yxx"
    { yyval.pFFeatures = yyvsp[0].pFFeatures; ;}
    break;

  case 245:
#line 1238 "mql.yxx"
    { yyval.pFFeatures = new CFFeatures(yyvsp[0].pFTerm); ;}
    break;

  case 246:
#line 1240 "mql.yxx"
    { yyval.pFFeatures = new CFFeatures(yyvsp[-2].pFFeatures, yyvsp[0].pFTerm); ;}
    break;

  case 247:
#line 1244 "mql.yxx"
    { yyval.pFTerm = new CFTerm(yyvsp[0].pFFactor); ;}
    break;

  case 248:
#line 1246 "mql.yxx"
    { yyval.pFTerm = new CFTerm(yyvsp[-2].pFFactor, yyvsp[0].pFTerm); ;}
    break;

  case 249:
#line 1250 "mql.yxx"
    { yyval.pFFactor = new CFFactor(yyvsp[0].pFFactor); ;}
    break;

  case 250:
#line 1252 "mql.yxx"
    { yyval.pFFactor = new CFFactor(yyvsp[-1].pFFeatures); ;}
    break;

  case 251:
#line 1254 "mql.yxx"
    { yyval.pFFactor = new CFFactor(yyvsp[0].pFeature_comparison); ;}
    break;

  case 252:
#line 1258 "mql.yxx"
    { yyval.pFeature_comparison = new CFeature_comparison(yyvsp[-2].pString, yyvsp[-1].comparison_op, yyvsp[0].pValue); ;}
    break;

  case 253:
#line 1262 "mql.yxx"
    { yyval.comparison_op = kEqual; ;}
    break;

  case 254:
#line 1264 "mql.yxx"
    { yyval.comparison_op = kLessThan; ;}
    break;

  case 255:
#line 1266 "mql.yxx"
    { yyval.comparison_op = kGreaterThan; ;}
    break;

  case 256:
#line 1268 "mql.yxx"
    { yyval.comparison_op = kNotEqual; ;}
    break;

  case 257:
#line 1270 "mql.yxx"
    { yyval.comparison_op = kLessThanOrEqual; ;}
    break;

  case 258:
#line 1272 "mql.yxx"
    { yyval.comparison_op = kGreaterThanOrEqual; ;}
    break;

  case 259:
#line 1274 "mql.yxx"
    { yyval.comparison_op = kTilde; ;}
    break;

  case 260:
#line 1276 "mql.yxx"
    { yyval.comparison_op = kNotTilde; ;}
    break;

  case 261:
#line 1282 "mql.yxx"
    { yyval.pValue = new CValue(yyvsp[0].pString, kValEnumConst); ;}
    break;

  case 262:
#line 1284 "mql.yxx"
    { yyval.pValue = new CValue(yyvsp[0].integer); ;}
    break;

  case 263:
#line 1286 "mql.yxx"
    { yyval.pValue = new CValue(yyvsp[0].pString, kValString); ;}
    break;

  case 264:
#line 1288 "mql.yxx"
    { yyval.pValue = new CValue(yyvsp[0].pObjectReferenceUsage); ;}
    break;

  case 265:
#line 1292 "mql.yxx"
    { yyval.pString = yyvsp[0].pString; ;}
    break;

  case 266:
#line 1296 "mql.yxx"
    { yyval.pObjectReferenceUsage = new CObject_reference_usage(yyvsp[-2].pString, yyvsp[0].pString); ;}
    break;

  case 267:
#line 1300 "mql.yxx"
    { yyval.pBlocks = 0; ;}
    break;

  case 268:
#line 1302 "mql.yxx"
    { yyval.pBlocks = yyvsp[0].pBlocks; ;}
    break;

  case 269:
#line 1306 "mql.yxx"
    { yyval.pRest_of_block_str = new CRest_of_block_str(yyvsp[0].pBlock); ;}
    break;

  case 270:
#line 1308 "mql.yxx"
    { yyval.pRest_of_block_str = new CRest_of_block_str(yyvsp[-2].pBlock, yyvsp[0].pRest_of_block_str); ;}
    break;

  case 271:
#line 1310 "mql.yxx"
    { if (yyvsp[0].pRest_of_block_str->get_block()->is_gap_or_opt_gap_block() 
	  || yyvsp[-1].pBlock->is_gap_or_opt_gap_block()) {
        yyval.pRest_of_block_str = new CRest_of_block_str(yyvsp[-1].pBlock, yyvsp[0].pRest_of_block_str);
      } else {
	COpt_gap_block* pOGB = new COpt_gap_block(kNoRetrieve,0);
	CBlock* pB = new CBlock(pOGB);
	CRest_of_block_str* pROBS = new CRest_of_block_str(pB, yyvsp[0].pRest_of_block_str);
	yyval.pRest_of_block_str = new CRest_of_block_str(yyvsp[-1].pBlock, pROBS);
      }
    ;}
    break;

  case 272:
#line 1323 "mql.yxx"
    { yyval.pBlock = new CBlock(yyvsp[0].pOptGapBlock); ;}
    break;

  case 273:
#line 1325 "mql.yxx"
    { yyval.pBlock = new CBlock(yyvsp[0].pGapBlock); ;}
    break;

  case 274:
#line 1327 "mql.yxx"
    { yyval.pBlock = new CBlock(yyvsp[0].pObject_block); ;}
    break;

  case 275:
#line 1331 "mql.yxx"
    { yyval.pOptGapBlock = new COpt_gap_block(yyvsp[-2].retrieval,yyvsp[-1].pBlocks); ;}
    break;

  case 276:
#line 1335 "mql.yxx"
    { yyval.retrieval = kNoRetrieve; ;}
    break;

  case 277:
#line 1337 "mql.yxx"
    { yyval.retrieval = kNoRetrieve; ;}
    break;

  case 278:
#line 1339 "mql.yxx"
    { yyval.retrieval = kRetrieve; ;}
    break;

  case 279:
#line 1341 "mql.yxx"
    { yyval.retrieval = kRetrieveFocus; ;}
    break;

  case 280:
#line 1345 "mql.yxx"
    { yyval.pGapBlock = new CGap_block(yyvsp[-2].retrieval,yyvsp[-1].pBlocks); ;}
    break;

  case 281:
#line 1350 "mql.yxx"
    { yyval.pFeature = yyvsp[0].pFeature; ;}
    break;

  case 282:
#line 1352 "mql.yxx"
    { yyval.pFeature = 0; ;}
    break;

  case 283:
#line 1361 "mql.yxx"
    { yyval.pObject_block = new CObject_block(yyvsp[-7].pString, yyvsp[-6].pString, yyvsp[-5].retrieval, yyvsp[-4].firstlast, yyvsp[-3].pFFeatures, yyvsp[-2].pFeature, yyvsp[-1].pBlocks); ;}
    break;

  case 284:
#line 1365 "mql.yxx"
    { yyval.firstlast = kNoFirstLast; ;}
    break;

  case 285:
#line 1367 "mql.yxx"
    { yyval.firstlast = kLast; ;}
    break;

  case 286:
#line 1371 "mql.yxx"
    { yyval.pPower = new CPower(yyvsp[0].integer); ;}
    break;

  case 287:
#line 1375 "mql.yxx"
    { yyval.integer = 0; ;}
    break;

  case 288:
#line 1377 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;

  case 289:
#line 1379 "mql.yxx"
    { yyval.integer = yyvsp[0].integer+1; ;}
    break;

  case 290:
#line 1383 "mql.yxx"
    { yyval.integer = yyvsp[0].integer; ;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 3062 "mql_parser.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1386 "mql.yxx"





