/*
 * utils.h
 *
 * Utility functions for EMdF
 *
 * Ulrik Petersen
 * Created: 1/27-2001
 * Last update: 11/11-2001
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2001-2002  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, license version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 **************************************************************************/




#ifndef UTILS__H__
#define UTILS__H__

#include <string>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void ConvertDBName(const std::string& strIn, std::string& strOut);
char bool2char(bool in);
bool char2bool(char in);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* UTILS__H__ */
